/* unity-protocol.vapi generated by valac 0.17.5, do not modify. */

namespace Unity {
	namespace Protocol {
		[CCode (cheader_filename = "unity-protocol.h")]
		public class AnnotatedIcon : GLib.Object, GLib.Icon {
			public AnnotatedIcon (GLib.Icon? base_icon);
			public void add_hint (string name, GLib.Variant value);
			public unowned GLib.Variant? get_hint (string name);
			public Unity.Protocol.CategoryType category { get; set; }
			public GLib.Icon icon { get; set; }
			public string ribbon { get; set; }
		}
		[CCode (cheader_filename = "unity-protocol.h")]
		public class ApplicationPreview : Unity.Protocol.Preview {
			public ApplicationPreview ();
			public GLib.Icon app_icon { get; set; }
			public string copyright { get; set; }
			public string last_update { get; set; }
			public string license { get; set; }
			public uint num_ratings { get; set; }
			public float rating { get; set; }
		}
		[CCode (cheader_filename = "unity-protocol.h")]
		public class GenericPreview : Unity.Protocol.Preview {
			public GenericPreview ();
		}
		[CCode (cheader_filename = "unity-protocol.h")]
		public class MoviePreview : Unity.Protocol.Preview {
			public MoviePreview ();
			public uint num_ratings { get; set; }
			public float rating { get; set; }
			public string year { get; set; }
		}
		[CCode (cheader_filename = "unity-protocol.h")]
		public class MusicPreview : Unity.Protocol.Preview {
			public MusicPreview ();
			public void pause_uri (string uri);
			public void play_uri (string uri);
			public string track_data_address { get; set; }
			public string track_data_swarm_name { get; set; }
		}
		[CCode (cheader_filename = "unity-protocol.h")]
		public abstract class Preview : GLib.Object, Dee.Serializable {
			public Preview ();
			public void add_action (string id, string display_name, GLib.Icon? icon, uint layout_hint);
			public void add_action_with_hints (string id, string display_name, GLib.Icon? icon, uint layout_hint, owned GLib.HashTable<string,GLib.Variant> hints);
			public void add_info_hint (string id, string display_name, GLib.Icon? icon_hint, GLib.Variant value);
			public virtual void begin_updates ();
			public virtual GLib.Variant? end_updates ();
			public virtual GLib.HashTable<string,GLib.Variant>? end_updates_as_hashtable ();
			public unowned Unity.Protocol.PreviewActionRaw[] get_actions ();
			public unowned Unity.Protocol.InfoHintRaw[] get_info_hints ();
			public bool get_no_details ();
			public abstract unowned string get_renderer_name ();
			public static Unity.Protocol.Preview? parse (GLib.Variant data);
			public void preview_closed ();
			public void set_no_details (bool val);
			public virtual void update_property (GLib.HashTable<string,GLib.Variant> properties);
			public string description { get; set; }
			public GLib.Icon? image { get; set; }
			public string image_source_uri { get; set; }
			public string subtitle { get; set; }
			public string title { get; set; }
		}
		[CCode (cheader_filename = "unity-protocol.h")]
		public class SeriesPreview : Unity.Protocol.Preview {
			public SeriesPreview ();
			public void add_series_item (string title, string uri, GLib.Icon? icon);
			public override void begin_updates ();
			public override GLib.HashTable<string,GLib.Variant>? end_updates_as_hashtable ();
			public unowned Unity.Protocol.SeriesItemRaw[] get_items ();
			public override void update_property (GLib.HashTable<string,GLib.Variant> properties);
			public Unity.Protocol.Preview child_preview { get; set; }
			public int selected_item { get; set; }
		}
		[CCode (cheader_filename = "unity-protocol.h")]
		[DBus (name = "com.canonical.Unity.Lens")]
		public interface LensService : GLib.Object {
			public abstract async Unity.Protocol.ActivationReplyRaw activate (string uri, uint action_type) throws GLib.IOError;
			public abstract async GLib.HashTable<string,GLib.Variant> global_search (string search_string, GLib.HashTable<string,GLib.Variant> hints) throws GLib.IOError;
			public abstract async void info_request () throws GLib.IOError;
			public abstract async GLib.HashTable<string,GLib.Variant> search (string search_string, GLib.HashTable<string,GLib.Variant> hints) throws GLib.IOError;
			public abstract async void set_view_type (uint view_type) throws GLib.IOError;
			public abstract async void update_filter (string filter_name, GLib.HashTable<string,GLib.Variant> properties) throws GLib.IOError;
			public abstract async GLib.HashTable<string,GLib.Variant> update_preview_property (string uri, GLib.HashTable<string,GLib.Variant> values) throws GLib.IOError;
			public signal void changed (Unity.Protocol.LensInfo lens_info);
		}
		[CCode (cheader_filename = "unity-protocol.h")]
		[DBus (name = "com.canonical.Unity.Scope")]
		public interface ScopeService : GLib.Object {
			public abstract async Unity.Protocol.ActivationReplyRaw activate (string uri, uint action_type) throws GLib.IOError;
			public abstract async GLib.HashTable<string,GLib.Variant> global_search (string search_string, GLib.HashTable<string,GLib.Variant> hints) throws GLib.IOError, Unity.Protocol.ScopeError;
			public abstract async void info_request () throws GLib.IOError;
			public abstract async GLib.HashTable<string,GLib.Variant> search (string search_string, GLib.HashTable<string,GLib.Variant> hints) throws GLib.IOError, Unity.Protocol.ScopeError;
			public abstract async void set_active_sources (string[] sources) throws GLib.IOError;
			public abstract async void set_view_type (uint view_type) throws GLib.IOError;
			public abstract async GLib.HashTable<string,GLib.Variant> update_preview_property (string uri, GLib.HashTable<string,GLib.Variant> values) throws GLib.IOError;
			public signal void changed (Unity.Protocol.ScopeInfo lens_info);
		}
		[CCode (cheader_filename = "unity-protocol.h")]
		public struct ActivationReplyRaw {
			public string uri;
			public uint handled;
			public GLib.HashTable<string,GLib.Variant> hints;
		}
		[CCode (cheader_filename = "unity-protocol.h")]
		public struct InfoHintRaw {
			public string id;
			public string display_name;
			public string icon_hint;
			public GLib.Variant value;
		}
		[CCode (cheader_filename = "unity-protocol.h")]
		public struct LensInfo {
			public string dbus_path;
			public bool search_in_global;
			public bool visible;
			public string search_hint;
			public string private_connection_name;
			public string results_model_name;
			public string global_results_model_name;
			public string categories_model_name;
			public string filters_model_name;
			public GLib.HashTable<string,GLib.Variant> hints;
		}
		[CCode (cheader_filename = "unity-protocol.h")]
		public struct PreviewActionRaw {
			public string id;
			public string display_name;
			public string icon_hint;
			public uint layout_hint;
			public GLib.HashTable<string,GLib.Variant> hints;
			public PreviewActionRaw ();
			public static Unity.Protocol.PreviewActionRaw? from_variant (GLib.Variant v);
			public GLib.Variant to_variant ();
		}
		[CCode (cheader_filename = "unity-protocol.h")]
		public struct ScopeInfo {
			public string dbus_path;
			public GLib.Variant sources;
			public bool search_in_global;
			public string private_connection_name;
			public string results_model_name;
			public string global_results_model_name;
			public string filters_model_name;
			public GLib.HashTable<string,GLib.Variant> hints;
		}
		[CCode (cheader_filename = "unity-protocol.h")]
		public struct SeriesItemRaw {
			public string uri;
			public string title;
			public string icon_hint;
		}
		[CCode (cheader_filename = "unity-protocol.h")]
		public enum ActionType {
			ACTIVATE_RESULT,
			PREVIEW_RESULT,
			PREVIEW_ACTION,
			PREVIEW_BUILTIN_ACTION
		}
		[CCode (cheader_filename = "unity-protocol.h")]
		public enum CategoryType {
			NONE,
			BOOK,
			MUSIC,
			MOVIE,
			GAMES,
			ELECTRONICS,
			COMPUTERS,
			OFFICE,
			HOME,
			GARDEN,
			PETS,
			TOYS,
			CHILDREN,
			BABY,
			CLOTHES,
			SHOES,
			WATCHES,
			SPORTS,
			OUTDOORS,
			GROCERY,
			HEALTH,
			BEAUTY,
			DIY,
			TOOLS,
			CAR,
			N_CATEGORIES
		}
		[CCode (cheader_filename = "unity-protocol.h")]
		public enum HandledType {
			NOT_HANDLED,
			SHOW_DASH,
			HIDE_DASH,
			GOTO_DASH_URI,
			SHOW_PREVIEW
		}
		[CCode (cheader_filename = "unity-protocol.h")]
		public enum LayoutHint {
			NONE,
			LEFT,
			RIGHT,
			TOP,
			BOTTOM
		}
		[CCode (cheader_filename = "unity-protocol.h")]
		public enum PlayState {
			STOPPED,
			PLAYING,
			PAUSED
		}
		[CCode (cheader_filename = "unity-protocol.h")]
		public enum ViewType {
			HIDDEN,
			HOME_VIEW,
			LENS_VIEW
		}
		[CCode (cheader_filename = "unity-protocol.h")]
		[DBus (name = "com.canonical.Unity.ScopeError")]
		public errordomain ScopeError {
			SEARCH_CANCELLED,
			UNKNOWN
		}
	}
}
